This file contains example code for using builtin topics.
The example shows how to create builtin DataReaders to examine new publications 
and subscriptions in the DDS data space. Each time a new entity is discovered, the 
topic name, type name and IDL structure are printed.

myTypeCodeSpy.cc
----------------
// This little spy application will listen for type code information on the
// wire and alert you of a new topic.

#include <stdlib.h>
#include <stdio.h>
#include "spyAgent.h"
#include "ndds/ndds_cpp.h"

int
main(int argc, char** argv) {

    int domainId = 10;
    struct DDS_Duration_t spy_duration = {60,0};
    struct DDS_Duration_t wait_period = {1,0};
    SpyAgent *spy = new SpyAgent();
   
    if (argc >= 2) {
        domainId = atoi(argv[1]);
    }
    if (argc >= 3) {
        spy_duration.sec = atoi(argv[2]);
    }
   
    spy->startSpying(domainId);
    printf("\n\n *** We're spying ***\n\n");
   
    while (1) {
        NDDS_Utility_sleep(&wait_period);
    }  

    spy->stopSpying();
    return 1;
}

